SystemOrganization addCategory: #'GT-ClassicCoder'!

GLMBrowserTemplate subclass: #GTClassicCoderCategoriesMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ClassicCoder'!

!GTClassicCoderCategoriesMethods commentStamp: 'TudorGirba 7/17/2011 13:27' prior: 0!
| browser |
browser := self new browser.
(browser pane port: #entity) value: {RPackageOrganizer default packages last . RPackageOrganizer default packages last classes anyOne}.
browser open!

!GTClassicCoderCategoriesMethods methodsFor: 'building' stamp: 'TudorGirba 10/2/2011 22:43'!
buildBrowser
	browser := GLMTabulator new.
	browser column: #categories; column: #methods.
	browser transmit
		toOutsidePort: #package;
		fromOutsidePort: #entity;
		transformed: [:packageAndClass | packageAndClass first ].
	browser transmit
		toOutsidePort: #class;
		fromOutsidePort: #entity;
		transformed: [:packageAndClass | packageAndClass last ].
	browser transmit
		to: #categories;
		fromOutsidePort: #package;
		fromOutsidePort: #class;
		andShow: [:a | self categoriesIn: a ].
	browser transmit 
		to: #methods; 
		fromOutsidePort: #package;
		fromOutsidePort: #class;
		from: #categories; 
		andShow: [ :a | self methodsIn: a ].
	browser transmit 
		toOutsidePort: #selectedCategory;
		from: #categories.
	browser transmit 
		toOutsidePort: #selectedMethod;
		from: #methods.
	browser transmit to: #categories port: #selection; fromOutsidePort: #focusOnMethod; transformed: [:m | m category ].
	browser transmit to: #methods port: #selection; fromOutsidePort: #focusOnMethod.
	^ browser! !

!GTClassicCoderCategoriesMethods methodsFor: 'private' stamp: 'TudorGirba 1/2/2014 14:08'!
categoriesIn: a
	a list
		title: 'Categories';
		allowsDeselection;
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance;
		display: [ :package :class | class organization categories ];
 		format: [:each :package :class |
			(self isCategory: each of: class definedIn: package)
				ifTrue: [each asString]
				ifFalse: [Text string: each asString attribute: TextColor gray] ]! !

!GTClassicCoderCategoriesMethods methodsFor: 'private' stamp: 'TudorGirba 10/3/2011 07:51'!
isCategory: aString of: aClass definedIn: aPackage

	^ (aClass isDefinedInPackage: aPackage) 
		ifTrue: [ (aString beginsWith: '*') not ]
		ifFalse: [ aString = ('*', aPackage name) ]! !

!GTClassicCoderCategoriesMethods methodsFor: 'private' stamp: 'TudorGirba 1/2/2014 14:09'!
methodsIn: a 
	a list
		title: 'Methods';
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance;
		display: [ :package :class :category | 
			(class methods select: [:each | each category = category]) asSortedCollection: [:x :y | x selector < y selector ] ];
		format: [:each :package :class |
			((each isDefinedInPackage: package) or: [each isExtensionInPackage: package])
				ifTrue: [each selector asString]
				ifFalse: [Text string: each selector asString attribute: TextColor gray] ].
	a list
		title: 'Methods';
		useExplicitNotNil;
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance;
		when: [ :package :class :category | class notNil and: [ category isNil ] ];
		display: [ :package :class :category | 
			class methods asSortedCollection: [:x :y | x selector < y selector ] ];
		selectionAct: [:list :package :class | 
			(Array with: package with: class with: list selection) inspect  ] on: $i entitled: 'Inspect';
		format: [:each :package :class |
			((each isDefinedInPackage: package) or: [each isExtensionInPackage: package])
				ifTrue: [each selector asString]
				ifFalse: [Text string: each selector asString attribute: TextColor gray] ]! !

GLMBrowserTemplate subclass: #GTClassicCoderInstanceAndMetaCategoriesMethods
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ClassicCoder'!

!GTClassicCoderInstanceAndMetaCategoriesMethods commentStamp: 'TudorGirba 7/17/2011 13:27' prior: 0!
| browser |
browser := self new browser.
(browser pane port: #entity) value: {RPackageOrganizer default packages last . RPackageOrganizer default packages last classes anyOne}.
browser open!

!GTClassicCoderInstanceAndMetaCategoriesMethods methodsFor: 'building' stamp: 'TudorGirba 10/2/2011 15:17'!
buildBrowser
	browser := GLMStacker new.
	browser aPane: #instance; aPane: #meta.
	browser transmit
		when: [ :packageClass | packageClass last notNil ];
		to: #instance;
		andShow: [ :a | 
					a title: 'Instance'.
					a custom: GTClassicCoderCategoriesMethods new browser ].
	(browser transmit)
		transformed: [ :packageClass | packageClass last ifNotNil: [ {packageClass first. packageClass last theMetaClass} ] ];
		when: [ :packageClass | packageClass last notNil ];
		to: #meta;
		andShow: [ :a | 
					a title: 'Meta'.
					a custom: GTClassicCoderCategoriesMethods new browser ].
	(browser transmit)
		toOutsidePort: #selectedMethod;
		from: #instance port: #selectedMethod.
	(browser transmit)
		toOutsidePort: #selectedMethod;
		from: #meta port: #selectedMethod.
	browser transmit to: #instance port: #focusOnMethod; fromOutsidePort: #focusOnMethod.
	browser transmit to: #meta port: #focusOnMethod; fromOutsidePort: #focusOnMethod.
	^ browser! !

GLMGlobalBrowserTemplate subclass: #GTClassicCoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-ClassicCoder'!

!GTClassicCoder commentStamp: 'TudorGirba 9/6/2012 23:20' prior: 0!
self open maximize
"| browser |
browser := self new browser.
browser openOn: RPackageOrganizer default.
browser inspect"!

!GTClassicCoder class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/1/2010 23:40'!
open
	^ self openOn: RPackageOrganizer default
! !

!GTClassicCoder methodsFor: 'building' stamp: 'TudorGirba 2/26/2012 13:59'!
browserActionsIn: b
	b morphicAct: [:theBrowser :organizer |
				| selected  composite packageRequest classRequest |
				composite  := GLMSpotterRequest new.

				packageRequest := GLMSingleSpotterRequest new 
						prompt: 'Find Package';
						searchBlock: [ :string | 
							organizer packages select: [:each |
								GLMSingleSpotterRequest substring: string matches: each name caseSensitive: false ] ];
						labelBlock: [ :p | p name ].
				classRequest := GLMSingleSpotterRequest new 
						prompt: 'Find Class';
						searchBlock: [ :string | 
							Smalltalk allClassesAndTraits select: [:each |
								GLMSingleSpotterRequest substring: string matches: each name caseSensitive: false ] ];
						labelBlock: [ :c | c name ].
						
				selected := composite add: packageRequest; add: classRequest; signal.
				(selected isKindOf: RPackage)
					ifTrue: [ (b pane port: #packageToSelect) value: selected ].
				(selected isKindOf: Behavior )
					ifTrue: [ (b pane port: #classToSelect) value: selected ].
				]
			on: $/ 
			icon: MooseIcons mooseSearch 
			entitled: 'Find package'! !

!GTClassicCoder methodsFor: 'building' stamp: 'TudorGirba 9/6/2012 23:18'!
buildBrowser
	"
	| browser |
	browser := self new browser.
	browser openOn: RPackageOrganizer default.
	browser"
	browser := GLMTabulator new.
	browser title: 'Glamorous Classic Coder'.
	self browserActionsIn: browser.
	browser column: #packages; column: #classes; column: [:c |
		c row: #categoriesAndMethods; row: #details ] span: 4.
	browser transmit 
		to: #packages; 
		andShow: [ :a | self packagesIn: a ].
	browser transmit 
		from: #packages; 
		to: #classes; 
		andShow: [ :a | self classesIn: a ].
	browser transmit
		from: #packages;
		from: #classes;
		to: #categoriesAndMethods;
		transformed: [:package :class | {package . class}];
		andShow: [ :a | self categoriesAndMethodsIn: a ].
	browser transmit 
		from: #packages;
		from: #classes;
		from: #categoriesAndMethods port: #selectedMethod;
		to: #details;
		andShow: [ :a | self detailsIn: a ].
	browser transmit to: #packages port: #selection; fromOutsidePort: #packageToSelect.
	browser transmit to: #packages port: #selection; fromOutsidePort: #classToSelect; transformed: #package.
	browser transmit to: #classes port: #selection; fromOutsidePort: #classToSelect.

	browser transmit toOutsidePort: #focusOnMethod; from: #details port: #focusOnMethod.
	browser transmit to: #packages port: #selection; fromOutsidePort: #focusOnMethod; transformed: [:method | method packageFromOrganizer: RPackageOrganizer default].
	browser transmit to: #classes port: #selection; fromOutsidePort: #focusOnMethod; transformed: [:method | method methodClass ].
	browser transmit to: #categoriesAndMethods port: #focusOnMethod; fromOutsidePort: #focusOnMethod.
	^ browser! !

!GTClassicCoder methodsFor: 'building' stamp: 'TudorGirba 1/8/2011 02:46'!
categoriesAndMethodsIn: a
	a custom: (GTClassicCoderInstanceAndMetaCategoriesMethods new browser)! !

!GTClassicCoder methodsFor: 'others' stamp: 'TudorGirba 11/26/2010 09:30'!
classPointOfViewBrowser
	"self new classPointOfViewBrowser openOn: RPackageOrganizer default"
	browser := GLMTabulator new.
	browser column: #packages; column: #classes; column: #definingPackages; column: #methods.
	browser transmit to: #packages; andShow: [ :a |
		a list 
			display: [ :organizer | organizer packages asSortedCollection: [ :x :y | x name < y name ] ];
			format: #name ].
	browser transmit to: #classes; from: #packages; andShow: [ :a | 
		a list
			display: [ :package | package classes ];
			format: [ :each :package |
				(package extendsClass: each)
					ifTrue: [Text string: each name asString attribute: TextColor gray]
					ifFalse: [each name asString] ];
			selectionAct: [:list | list selection inspect] on: $/ entitled: 'Inspect' ].
	browser transmit to: #definingPackages; from: #classes; andShow: [ :a | 
		a list 
			display: [ :class | class packages];
			format: #name ].
	browser transmit to: #methods; from: #definingPackages; from: #classes; andShow: [ :a | 
		a list 
			title: 'Instance';
			display: [ :package :class | package selectorsForClass: class ];
			selectionAct: [:list :package :class | (Array with: package with: class with: list selection) inspect  ] on: $/ entitled: 'Inspect';
			format: [:each :package :class |
				(package includesSelector: each ofClass: class) 
					ifFalse: [Text string: each asString attribute: TextColor gray]
					ifTrue: [each asString] ].
		a list 
			title: 'Meta';
			display: [ :package :class | class theMetaClass selectors ];
			format: [:each :package :class |
				(package includesSelector: each ofClass: class class) 
					ifFalse: [Text string: each asString attribute: TextColor gray]
					ifTrue: [each asString] ] ].
	^ browser! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/2/2014 16:09'!
classReferencesIn: a
	(a list)
		title: 'References';
		useExplicitNotNil;
		when: [ :package :class | class notNil ];
		display: [ :package :class | self systemNavigation allCallsOn: (self globals associationAt: class theNonMetaClass name) ];
		selectionPopulate: #focusOnMethod
			on: $j
			entitled: 'Jump there'
			with: [ :list | list selection compiledMethod ];
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 9/21/2011 00:20'!
classSourceIn: a
	a smalltalkCode
		title: 'Class';
		useExplicitNotNil;
		when: [ :package :class :method | class notNil and: [ method isNil ] ];
		display: [ :package :class | class definition ]! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/2/2014 16:09'!
classesIn: a 
	a list
		title: 'Classes';
		display: [ :package | package classes];
		sorted: [:x :y | x name < y name ];
"		icon: [ :each | 
			each theNonMetaClass browserIcon isNil 
				ifFalse: [ OBMorphicIcons iconNamed: each theNonMetaClass browserIcon ]
				ifTrue: [ nil ] ];"
		format: [ :each :package |
			(package extendsClass: each)
				ifTrue: [Text string: each name asString attribute: TextColor gray]
				ifFalse: [each name asString] ];
		selectionAct: [:list | list selection inspect] on: $i entitled: 'Inspect';
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 7/17/2011 12:37'!
detailsIn: a
	self methodSourceCodeIn: a.
	self classSourceIn: a.
	self classReferencesIn: a.
	self sendersIn: a.
	self implementorsIn: a! !

!GTClassicCoder methodsFor: 'accessing' stamp: 'TudorGirba 7/17/2011 12:37'!
entity
	^ RPackageOrganizer default! !

!GTClassicCoder methodsFor: 'others' stamp: 'TudorGirba 2/26/2012 13:17'!
globals 
	^ Smalltalk globals! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/2/2014 16:09'!
implementorsIn: a
	(a list)
		title: 'Implementors';
		display: [ :package :class :method | (self systemNavigation allImplementorsOf: method selector) ];
		selectionPopulate: #focusOnMethod
			on: $j
			entitled: 'Jump there'
			with: [ :list | list selection compiledMethod ];
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 10/1/2011 21:21'!
methodSourceCodeIn: a
	a smalltalkCode 
		title: 'Method';
		smalltalkClass: [:package :class | class ];
		act: [:text :package :class | class compile: text text notifying: nil ] 
			icon: GLMUIThemeExtraIcons glamorousAccept 
			on: $s
			entitled: 'Accept';
		act: [:text :package :class :method | class removeSelector: method selector ] 
			icon: GLMUIThemeExtraIcons glamorousRemove
			on: $x
			entitled: 'Remove';
		display: [:package :class :method |
			method getSource ]! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/2/2014 16:09'!
packagesIn: a 
	a list 
		title: 'Packages';
		display: [ :organizer | organizer packages ];
		sorted: [:x :y | x name < y name ];
		format: [:each | each name];
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance! !

!GTClassicCoder methodsFor: 'reusable' stamp: 'TudorGirba 1/2/2014 16:09'!
sendersIn: a
	(a list)
		title: 'Senders';
		display: [ :package :class :method | self systemNavigation allSendersOf: method selector];
		selectionPopulate: #focusOnMethod
			on: $j
			entitled: 'Jump there'
			with: [ :list | list selection compiledMethod ];
		updateOn: SystemAnnouncement from: SystemAnnouncer uniqueInstance! !
